﻿using System;
using Microsoft.SPOT;

using ToolBoxes;

namespace OutilsRadar
{
   public static class LedCard
    {       
        public enum LEDs : byte
        {
            All_On = 0x00,
            DO_On = 0xFE,
            D1toD0_On = 0xFC,
            D2toD0_On = 0xF8,
            D3toD0_On = 0xF0,
            D4toD0_On = 0xE0,
            D5toD0_On = 0xC0,
            D6toD0_On = 0x80,            
            All_Off = 0xFF
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="LedsOnI2CCard"></param>
        /// <param name="Leds"></param>
        /// <param name="Lcd"></param>
        /// <param name="PositionBPs"></param>
        /// <param name="distance"></param>
        public static void Affiche(LEDs LedsOnI2CCard, PCF8574 Leds, ELCD162 Lcd, UInt16 PositionBPs, UInt16 distance, byte increment)
        {
            Leds.Write((byte)LedsOnI2CCard);
            Lcd.ClearScreen();
            Lcd.PutString("Dmin:" + PositionBPs + "cm" + " Inc:" + increment);
            Lcd.SetCursor(0, 1);
            Lcd.PutString("Distance:" + distance + "cm");
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="increment"></param>
        /// <param name="LedsOnI2CCard"></param>
        /// <param name="PositionBPs"></param>
        /// <param name="distance"></param>
        /// <returns></returns>
        public static LEDs TraiterDistance(byte increment, UInt16 PositionBPs, UInt16 distance)
        {
            LEDs LedsOnI2CCard;

            if (distance < PositionBPs)
            {
                LedsOnI2CCard = LEDs.All_On;
            }
            else if ((distance >= PositionBPs) && (distance < (PositionBPs + increment)))
            {
                LedsOnI2CCard = LEDs.D6toD0_On;
            }
            else if ((distance >= (PositionBPs + increment)) && (distance < (PositionBPs + 2 * increment)))
            {
                LedsOnI2CCard = LEDs.D5toD0_On;
            }
            else if ((distance >= (PositionBPs + 2 * increment)) && (distance < (PositionBPs + 3 * increment)))
            {
                LedsOnI2CCard = LEDs.D4toD0_On;
            }
            else if ((distance >= (PositionBPs + 3 * increment)) && (distance < (PositionBPs + 4 * increment)))
            {
                LedsOnI2CCard = LEDs.D3toD0_On;
            }
            else if ((distance >= (PositionBPs + 4 * increment)) && (distance < (PositionBPs + 5 * increment)))
            {
                LedsOnI2CCard = LEDs.D2toD0_On;
            }
            else if ((distance >= (PositionBPs + 5 * increment)) && (distance < (PositionBPs + 6 * increment)))
            {
                LedsOnI2CCard = LEDs.D1toD0_On;
            }
            else if ((distance >= (PositionBPs + 6 * increment)) && (distance < (PositionBPs + 7 * increment)))
            {
                LedsOnI2CCard = LEDs.DO_On;
            }
            else if (distance >= (PositionBPs + 7 * increment))
            {
                LedsOnI2CCard = LEDs.All_Off;
            }
            else
                LedsOnI2CCard = LEDs.All_Off;
            return LedsOnI2CCard;
        }
    }
}
